2019-06-13  Werner Koch  <wk@gnupg.org>

	Release 1.13.1.
	+ commit ea11c2a13cd44caf0bab395bd5132bf232318ad8
	* configure.ac: Bump LT versions to c=C33/A22/R1 cpp=C16/A10/R0
	qt=C10/A3/R4.

	python: Fix regression in t-decrypt-verify test.
	+ commit 7d0a979c07d2a32c1e39a9403f009cbe026f77ff
	* lang/python/tests/t-decrypt-verify.py: Comment recent changes.

	python: Set a default-key into gpg.conf for the tests.
	+ commit ad1395f210f3a3d5839f482f1933eac80a94d174
	* lang/python/tests/Makefile.am (gpg.conf): Set a default key.

	core: At debug levels up to 9 print only an ascii dump.
	+ commit 4f11210b21a1914a1daf67474e9b82084b2cac01
	* src/debug.c (_gpgme_debug_buffer): Switch between two output
	formats.

2019-06-06  Werner Koch  <wk@gnupg.org>

	tests: Minor fix to run-threaded.c.
	+ commit f6fd90c99aea8b604d76ae49d29bc5269c236a98
	* tests/run-threaded.c (random_data_close): Correct FD test.

	core: Add commented debug helper to posix-io.c.
	+ commit f84abcad253ace782708c05760e52793814896f4
	* src/posix-io.c (_gpgme_is_fd_valid): New out-commented function.

	core: Fix error return value of _gpgme_run_io_cb.
	+ commit 6b9ff1ba391a4364b37cb116748194f3f33b4f12
	* src/wait.c (_gpgme_run_io_cb): Fix return code.

2019-06-06  Andre Heinecke  <aheinecke@gnupg.org>

	tests: Add option "allow-del" to run-threaded.
	+ commit e6f28273062ff26344163e219c1b784ae99de980
	* tests/run-threaded.c (main): Handle allow-del.
	(allow-del): New. Variable to allow deletion of keys.
	(import): Delete key after import if allow-del is set.
	(delete_impres): Delete keys from an import result.
	(delete_fpr): Delete a key by fingerprint.

2019-06-05  Andre Heinecke  <aheinecke@gnupg.org>

	tests: Implement import in run-threaded.
	+ commit 024a7f75d4b8e017b92a13552b23e7fb1d22a5ce
	* tests/run-threaded.c (import): New.
	(do_data_op): Call it.

2019-06-05  Werner Koch  <wk@gnupg.org>

	core: Prettify _gpgme_io_select debug output again and fix TRACE_SYSRES.
	+ commit 0f68c9f16bdae7295cac4cbf3c9a197840989a85
	* src/debug.c (_gpgme_debug): Take better care of NULL userinfo.
	(_gpgme_debug_end): Rework.
	(_trace_sysres): Print ERRNO and not the supplied RES.

2019-06-05  Andre Heinecke  <aheinecke@gnupg.org>

	tests: Use synced output for error in run-threaded.
	+ commit 3a3648e3a56712261bda4fa866bd2419a740cec8
	* tests/run-threaded.c (do_data_op): Use synced out macro.

	tests: Avoid variable named the same as a macro.
	+ commit 3a11421d0f63b8cb5afa407cd65f763b11033241
	* tests/run-threaded.c (decrypt, verify): Don't use a variable name
	that is also a macro.

	tests,w32: Fix thread creation in run-threaded.
	+ commit 9bbe15ebbc41533fa219d5b3017a26a75bc72731
	* tests/run-threaded.c (create_thread): Check proper return
	value and not return value of CloseHandle.

2019-06-05  Werner Koch  <wk@gnupg.org>

	core: Improve the debug messages even more.
	+ commit 8f9f3224aac78ce9d54e19e73acf7ab659787168
	* src/debug.c (_gpgme_debug): Add arg LINE.  Chnage all callers.
	(_gpgme_debug_begin): Remove.
	* src/debug.h (TRACE_SEQ): Use the LINE arg of _gpgme_debug.

	core: Avoid explicit locks in the debug code.
	+ commit 856d2e8d64f668855b1c22d3d38fe783904c6c48
	* src/debug.c (debug_lock): Remove.  Also remove all users.
	(_gpgme_debug): Use gpgrt_bsprintf to prepare the output and finally
	print using standard fprintf.  Reformat to prefix to be narrower.

2019-06-04  Werner Koch  <wk@gnupg.org>

	json: Print "nan", "-inf", "inf" if needed.
	+ commit f56c996318dfa1c9f0d10582b18c2fce10d24668
	* src/cJSON.c (print_number): Print NaN and INF.

	json: Improve handling of large exponents in the JSON parsor.
	+ commit fabe96126b4ed9c5e07b713813d7db26a02e5e5f
	* src/cJSON.c: Include stdint.h.
	(parse_number): Avoid overflob in SUBSCALE and cap integer values.

	core: Implement recpstring option parsing for gpgsm.
	+ commit 1024884e07f750ce781fa74dffa62e126bdda622
	* src/engine-gpg.c (append_args_from_recipients_string): Detect bad
	options.
	* src/engine-gpgsm.c (set_recipients_from_string): Implement option
	parsing.

	core: Make gpgme_op_encrypt_ext work for CMS.
	+ commit e9ca36f876e1066227668981f5a9e1a7f1031d9e
	* src/engine-gpgsm.c (gpgsm_encrypt): Fix argument check.

2019-06-04  NIIBE Yutaka  <gniibe@fsij.org>

	python: Fix typo in DecryptionError exception.
	+ commit 47135ffdb923de66bc275a37e31811ad22c73dd7
	* lang/python/src/errors.py (DecryptionError): Rename from
	DeryptionError.
	(UnsupportedAlgorithm): Use DecryptionError.

2019-06-03  Andre Heinecke  <aheinecke@gnupg.org>

	Add NEWS for 1.13.1.
	+ commit 49883023f661a18d73f9f2c7a3a98902af62ef6b
	* NEWS: Add news for 1.13.1

2019-05-06  Andre Heinecke  <aheinecke@gnupg.org>

	python: Make EXTRA_DIST files explicit.
	+ commit f9c923bb2d87711235312e8085964372d7480ce4
	* configure.ac: Configure new Makefiles.
	* lang/python/Makefile.am: Remove dirs from extra dist and use
	subdirs.
	* lang/python/examples/Makefile.am, lang/python/src/Makefile.am,
	lang/python/doc/Makefile.am: New. Files that list EXTRA_DIST files.

	Python, doc: Minor style improvement.
	+ commit 63055f13407760c877e5a3a94e564dfb3077dd47
	* lang/python/src/core.py (Context): Retab and shorten
	max line length.

	Merge remote-tracking branch 'origin/dkg/fix-T4276'
	+ commit f303806a110a9813023a5fd9468a55ab0f7fb39d


2019-05-03  Andre Heinecke  <aheinecke@gnupg.org>

	Always use maintainer mode -Wno cflags.
	+ commit 33b13d1c290d7ce35c636cce4265b512fb8e64c3
	* configure.ac (CFLAGS): Move -Wno flags out of the maintainer mode.

	cpp: Fix initialization warning.
	+ commit 0ed81498147723f0e9282df5ae08b8b8e40edd2f
	* lanc/cpp/src/gpggencardkeyinteractor.cpp
	(GpgGenCardKeyInteractor::Private): Fix initialization warning.

2019-05-03  Daniel Kahn Gillmor  <dkg@fifthhorseman.net>

	python: stop raising BadSignatures from decrypt(verify=True)
	+ commit 4100794e305ba22241ea5a4f7b42bb5189fbd948
	* src/core.py (decrypt): filter out signatures with errors from the
	returned verify_result, but avoid raising BadSignatures
	* tests/t-decrypt-verify.py: ensure that only a single signature is
	returned when evaluating cipher-3.asc, since the other signature is
	unknown.

	python/tests: try to decrypt and verify new test data.
	+ commit bd2d282e572b5d02669238c9e087259b85638477
	* lang/python/tests/t-decrypt.py: test decryption of cipher-3.asc and
	cipher-no-sig.asc
	* lang/python/tests/t-decrypt-verify.py: test decryption and
	verification of cipher-3.asc and cipher-no-sig.asc

	tests: add two new types of encrypted data.
	+ commit c5c3a9d10be415ea7bc0cd9730ad6085f16ee7a0
	* tests/gpg/cipher-3.asc: add an encrypted file containing signatures
	(one from a known key, and one from an unknown key)
	* tests/gpg/cipher-no-sig.asc: add an encrypted file containing no
	signatures at all

	python: make it easier to run a limited number of tests.
	+ commit 30bd1c097544376f257d426d5feb4706fb5d3afd
	* lang/python/tests/Makefile.am: prefer py_tests from the environment
	if present.

2019-05-02  Andre Heinecke  <aheinecke@gnupg.org>

	tests: Add cms mode to run-import.
	+ commit 4746c5c9e2dd9a3ee471a429c19bc1f7fd1d07db
	* tests/run-import.c (show_usage): Add doc for cms / openpgp.
	(main): Handle protocol.

2019-04-24  Andre Heinecke  <aheinecke@gnupg.org>

	cpp: Add wrapper for gpgme_set_global_flag.
	+ commit 7981ec4147f3058d5b56905903456247993dc6f7
	* lang/cpp/src/context.cpp (setGlobalFlag): New.
	* lang/cpp/src/global.h (setGlobalFlag): Export it.

2019-04-19  NIIBE Yutaka  <gniibe@fsij.org>

	core: Fix duplication of close_notify_handler for gpgsm.
	+ commit 7673ef7953482f42cab50dca1810e5c9d10f461e
	* src/engine-gpgsm.c [!USE_DESCRIPTOR_PASSING] (gpgsm_new): Remove
	last call to _gpgme_io_set_close_notify.

	core: Fix error return.
	+ commit 814f6c8de8006830f19a029a879bd92f9e584789
	* src/engine.c (_gpgme_set_engine_info): Add error return.

2019-04-09  Andre Heinecke  <aheinecke@gnupg.org>

	core,w32: Fix minor potential memleak.
	+ commit 140d694e1fddf16fa3fd2371b9a852ebb14622c8
	* src/w32-util.c (_gpgme_create_process_utf8): Free converted
	startup info strings.

	core,w32: Fix new w32-util functions.
	+ commit ecbba12b869106ba03e10b7b7dd80f74d086831b
	* src/w32-util.c (_gpgme_access): Respect mode parameter.
	(_gpgme_create_process_utf8): Convert startupinfo, too.

	core,w32: Improve handling of Unicode paths.
	+ commit a82e3a0ae57a48ba173e282a050680751006c074
	* src/dirinfo.c (get_gpgconf_item): Use _gpgme_access.
	* src/posix-util.c (_gpgme_access): Add forward to normal access.
	* src/sys-util.h (_gpgme_access): New for posix and w32.
	* src/w32-io.c (_gpgme_io_spawn): Use _gpgme_crate_process_utf8.
	* src/w32-util.c (utf8_to_wchar, utf8_to_wchar0): The usual w32 conv.
	(find_program_in_dir): Use _gpgme_access.
	(find_program_at_standard_place): Use wchar API and convert to UTF-8.
	(_gpgme_access): Convert UTF-8 to wchar and use wchar API.
	(_gpgme_create_process_utf8): Convert UTF-8 to wchar and use wchar API.

	core,w32: Show w32-spawn warning only once.
	+ commit 937adfdcbb22f715c5a331e5e2d4546ac15a1b7e
	* src/w32-io.c (_gpgme_io_spawn): Show MessageBox only once.

2019-03-27  Andre Heinecke  <aheinecke@gnupg.org>

	core, w32: Fix format string errors on windows.
	+ commit 4a4680f8901ecdcb7e8d5ed55f48226ccfccd7c8
	* src/debug.c (_gpgme_debug): Use gpgrt_vasprintf instead of
	vfprintf to have a more portable format.

	core: Fix assuan logger-fd hack for windows.
	+ commit 19a4c4daa2cfd075b181d5131a4b8b4d54714b8c
	* src/assuan-support.c (my_spawn): Zero is a perfectly fine fd.

2019-03-26  Andre Heinecke  <aheinecke@gnupg.org>

	core,w32,glib: Fix build of w32-glib-io.c.
	+ commit 213c4bc1eb1f45695cc3955cc722ebb363dcbdd0
	* src/w32-glib-io.c (_gpgme_io_pipe, _gpgme_io_connect): Do not
	use TRACE_SUC in a return statement.

2019-03-26  Werner Koch  <wk@gnupg.org>

	Release GPGME 1.13.0.
	+ commit 1b5a6bf27ac9b2e5a1fc4d5e879bd4901fcad5bb
	* configure.ac: Bump LT versions.
	                For C to C33/A22/R0.
	                For C++ to C15/A9/R0.
	                For Qt to C10/A3/R3.

2019-03-26  Andre Heinecke  <aheinecke@gnupg.org>

	core: Fix a strtoul to strtol.
	+ commit 10576dc427b3746e2c3b9bc40efe618a3bd40519
	* src/assuan-support.c (my_spawn): Fix using strtoul for
	a long.

	cpp: Fix GenCardKeyInteractor and extend it.
	+ commit ffdb75217bc09561cf651dab15cd26e0024d89a7
	* NEWS: Mention interface change.
	* lang/cpp/src/gpggencardkeyinteractor.cpp
	(GpgGenCardKeyInteractor::setAlgo): New.
	(GpgGenCardKeyInteractor::action),
	(GpgGenCardKeyInteractor::nextState: Handle new interface.

2019-03-25  Andre Heinecke  <aheinecke@gnupg.org>

	core, w32: Add hack to translate diag logger-fd.
	+ commit 129def87b262241483ba3a8b6771ad6d07c2e3be
	* src/assuan-support.c (my_spawn): Add hack to
	mark the logger fd for w32spawn translation.

2019-03-20  Andre Heinecke  <aheinecke@gnupg.org>

	qt: Handle diagnostic audit log for CMS.
	+ commit 47369569e23482bdd24a136b071192352b1d1347
	* lang/qt/src/threadedjobmixin.cpp(_detail::audit_log_as_html):
	Handle CMS audit log.

2019-03-19  Werner Koch  <wk@gnupg.org>
	    Andre Heinecke  <aheinecke@gnupg.org>

	core: Support GPGME_AUDITLOG_DIAG for gpgsm.
	+ commit dd21ec997cf4b6ba18538c63c728478110ad1f60
	* src/engine-gpgsm.c (struct engine_gpgsm): Add fields diag_cb and
	diagnostics.
	(close_notify_handler): Close the diag fd on status fd close.
	Handle diag close.
	(gpgsm_cancel): Handle diag.
	(gpgsm_release): Free DIAGNOSTICS.
	(gpgsm_new): Support the diag feature.
	(start): Set a handler for the diag fd.
	(gpgsm_getauditlog): Support GPGME_AUDITLOG_DIAG.

2019-03-13  Andre Heinecke  <aheinecke@gnupg.org>

	cpp: Fix Error::hasSystemError.
	+ commit c4cc47ee8f0bedc58e58ab416689d7014b0df2e7
	* lang/cpp/src/context.cpp (Error::hasSystemError): Invert logic to
	do what it says.

2019-02-28  Werner Koch  <wk@gnupg.org>

	json: Fix cosmetic error in the repl.
	+ commit 1bdab961c51fc038c33ae8116595aa0213ab1dd5
	* src/gpgme-json.c (native_messaging_repl): Use correct var with sizeof.

	tests: Let run-verify print the de-vs flag.
	+ commit b159b2eddd9df5df6cc8f29bd999cf1603c56991
	* tests/run-verify.c (print_result): Chack is_de_vs.
	* tests/run-import.c (main): Fix bad parameter for format string.

2019-02-27  Andre Heinecke  <aheinecke@gnupg.org>

	json: Limit recursion depth.
	+ commit 4a117859e7a512458ab78cfedfae0372805196b1
	* src/cJSON.c (MAX_DEPTH): New. Maximum recursion depth.
	(parse_value, parse_array, parse_object): Carry and check
	depth argument.
	(cJSON_ParseWithOpts): Initialize depth.

2019-02-21  Andre Heinecke  <aheinecke@gnupg.org>

	cpp: Add ostream operators for import result.
	+ commit 73b2f40ae5e6881991dea609b0781373b28d7d30
	* lang/cpp/src/importresult.cpp: Add ostream operators.
	* lang/cpp/src/importresult.h: Update accordingly.

	cpp: Make GpgME::Data::toKeys really const.
	+ commit 6175025c822678102c3f089e37952aa84b19a3ec
	* lang/cpp/src/data.cpp (GpgME::Data::toKeys): Rewind afterards.

2019-02-19  Werner Koch  <wk@gnupg.org>

	core,w32: Fix missing sentinel in dir name builder.
	+ commit 4c49417cc0dbd7f34269aff00fccafba150af744
	* src/w32-util.c (_gpgme_get_gpgconf_path): Add NULL top strconcat.

2019-02-11  Andre Heinecke  <aheinecke@gnupg.org>

	tests: Fix memleak in run-threaded.
	+ commit f8312d7c333193582dcb5816198219b9564023f0
	* tests/run-threaded.c (verify): Free msg.

2019-02-10  Ben McGinnes  <ben@adversary.org>

	python: examples.
	+ commit 302d5ef52e095378231efd54677b5c315354ad78
	* A rather obvious variant of the existing key import examples, except
	  directed at Mailvelope's keyserver.
	* Yeah, Werner, I know ... but it exists because I used it and there's
	  no harm in sharing.

2019-01-30  Ben McGinnes  <ben@adversary.org>

	python: docs.
	+ commit e005052f4d5b29beda2252f8042dbf5728f5e2aa
	* Version bump in preparation for whenever GPGME 1.13.0 happens.
	* Ran the post_installer.py for docs preparation again.

2019-01-27  Ben McGinnes  <ben@adversary.org>

	python: post installer script.
	+ commit 2de1e599770cdb129b84302d963f65fdd3ddd2a4
	* Removed auto-generated .texi files from doc/src/ so only the
	  corrected versions are left.
	* Which means now it is complete, but with the initial work to expand
	  it with info file generation later.

	python: post installer docs fix script.
	+ commit 1e265723653042bc1010b457537b69a2011b43b7
	* Moved post_installer.py into the examples/howto/ directory.
	* Added instructions for its use to the Python Bindings HOWTO.
	* Ran it as intended from the lang/python/ directory in order to both
	  prove it works and quickly and easily get the updated howto
	  replicated.  Also to fix all those .texi files.

2019-01-25  Werner Koch  <wk@gnupg.org>

	json: Better use gpgme_free.
	+ commit ed81892917f47dddc23aa99d88733e3f8f344256
	* src/gpgme-json.c (subkey_to_json): here

	json: Fix minor memory leaks.
	+ commit 7f2423371964263784252cf839269023b6573bd2
	* src/gpgme-json.c (interactive_repl): Fix memleak.
	(subkey_to_json): Ditto
	(op_config): Delay init of j_comps to avoid a leak on error.

2019-01-16  NIIBE Yutaka  <gniibe@fsij.org>

	build: With LD_LIBRARY_PATH defined, use --disable-new-dtags.
	+ commit 66bcb8acb2452cf19318023ed0ff1ea7d7bb8439
	* configure.ac (LDADD_FOR_TESTS_KLUDGE): New for --disable-new-dtags.
	* tests/Makefile.am (LDADD): Use LDADD_FOR_TESTS_KLUDGE.
	* lang/cpp/tests/Makefile.am, lang/qt/tests/Makefile.am: Likewise.
	* tests/gpg/Makefile.am, tests/gpgsm/Makefile.am: Likewise.
	* tests/json/Makefile.am, tests/opassuan/Makefile.am: Likewise.

2019-01-15  Andre Heinecke  <aheinecke@gnupg.org>

	tests: Add diagnostic example to run-import.c.
	+ commit ce327f994a2888b807b63cf202ddcecc3fb9c685
	* tests/run-import.c (main): Show diagnostics in verbose mode.

2019-01-09  Andre Heinecke  <aheinecke@gnupg.org>

	qt: Use tofu conflict test keys without expiry.
	+ commit 66376f3e206a1aa791d712fb8577bb3490268f60
	* lang/qt/tests/t-tofuinfo.cpp: Use new test keys without
	expiry.

2019-01-02  Ben McGinnes  <ben@adversary.org>

	python docs: post installer.
	+ commit a0dbdfebbb60f0d34dd16894803e95221d8be668
	* Merging post installer script.
	* Included ammended Sphinx config file to try to reduce the
	  auto-generated EPUB validation failures it produces.

	python: post installer doc fix script.
	+ commit a2e7c863c821ca035f1e3f8077bdae3b0f81f5eb
	* Got rid of the bash bit in the comments.
	* Made the final printed instructions far more obvious.

	python: examples.
	+ commit 207d4289d84971d11ec1824fbe7d4a2be63b56e4
	* Fixed inter-edit.py so it will actually work now.
	* made 3 others executable.
	* Fixed the semantics of assuan.py's instructions.

2018-12-26  Ben McGinnes  <ben@adversary.org>

	python: examples.
	+ commit d406471d4bf9c79140e4bc91de7d316ec7465892
	* Fixed inter-edit.py so it will actually work now.
	* made 3 others executable.
	* Fixed the semantics of assuan.py's instructions.

2018-12-24  Ben McGinnes  <ben@adversary.org>

	python: docs processing.
	+ commit ef9355c2fe8f81ccd73e0ed45ce33e925928f8e1
	* Added some EPUB specific config options to the Sphinx config file
	  which might help reduce some of Sphinx's more stupid default errors
	  with EPUB validation.
	* Added lang/python/post_installer.py script for automating the
	  generation of .texi and .rst "source" files from the real source
	  files written in Org mode.  Includes recreating the Sphinx Makefile
	  which is excluded due to the m4 toolchain in parent directories, it
	  also handles the rewriting of the reST index file properly and
	  rewrites the .texi files so they don't impale themselves on Unicode.

2018-12-21  Ben McGinnes  <ben@adversary.org>

	python: docs.
	+ commit 06bca0eaa8de8405fafc892ab7864990f8853bcf
	* Found a bug in org-mode's export to texinfo function which will
	  require either manual modification of each file or a customs sed run
	  over the generated files for all updates.
	* Manually updated the current files for now, but will need to add
	  some post-install processing scripts for future use (I already have
	  some of these for my specific setup, they just need to be made a
	  little more generic and platform independent for here).

	python: groups example.
	+ commit dc5f416351e47bfafb46a53f8fd8435dd6c231ba
	* Tightened code a little more.

2018-12-17  Ben McGinnes  <ben@adversary.org>

	python docs: house keeping.
	+ commit daded4925489d306f6a65271c2f55101b331187c
	* Dropped the ASCII copyright line, since even MS have conceded their
	  battle against Unicode enough to load UTF-8.
	* Fixed the drafts section since there will be less need of multiple
	  output format testing from next year.

2018-12-17  Werner Koch  <wk@gnupg.org>

	core: Silence newer compiler warnings.
	+ commit 8b41fb08f00f01fe0dd8b2b5455d3422d97ddc60
	* configure.ac: Add -Wno-format-truncation and
	  -Wno-sizeof-pointer-div.
	* src/b64dec.c (_gpgme_b64dec_proc): Add fallthrough annotation.
	* src/cJSON.c (parse_string): Ditto.
	* src/gpgme-json.c (main): Ditto.

2018-12-16  Ben McGinnes  <ben@adversary.org>

	python: howto and examples.
	+ commit fbc298dc1b0fbb51ebc92a9d56c45b78c5e9989d
	* Tightening up both the documentation and some of the example code.

2018-12-13  Ben McGinnes  <ben@adversary.org>

	python: examples bugfix.
	+ commit 4308d172816f3172454fac1dc0771014056764a1
	* Fixed a bug in the ProtonMail importers (pmkey-*.py) where multiple
	  keys found for a username would always result in the last email
	  address checked being returned in the printed output for all located
	  keys.

2018-12-12  Ben McGinnes  <ben@adversary.org>

	python: new example script.
	+ commit 3849b60e22432ef33f0d1d39b88e07922ad7779e
	* Though Keybase really should not be encouraged due to
	  disengenuosness and FUD emanating from that souce, this new script
	  will obtain a key hosted on that site and import it when supplied
	  with the keybase username.

	python: what's new summary.
	+ commit 3ca7cf07f5d3ec4af89e69ed13ea7ab701e33c03
	* Added a little more detail to the what's new section.

	python: advanced howto example.
	+ commit 64758a0dac4c7c3b312dccbc1661813e2c3e2888
	* Added Cython requirement to this advanced use case.

	python: howto examples equirements.
	+ commit 4c324ac1beb710714262af0040dea21232ba87d9
	* Added small requirements.txt file for additional modules not in the
	  standard python library and not including the bindings themselves
	  and not including Cython, which is for more advanced examples.

2018-12-10  Ben McGinnes  <ben@adversary.org>

	python: hkp key importer.
	+ commit 772b5aae24a2a3a996f399024845de612192fc2f
	* Tweaked it slightly to avoid repetition of key searches when there
	  is only one search pattern to check (i.e. usually a single key ID or
	  fingerprint).

	python: HKP search and import updates.
	+ commit 2e7a14c9b369096775a035091c197f2d438142a0
	* Tweaked the code again so that it can also handle the cases where
	  someone has included a hexadecimal string in their user ID.
	* Updated the HOWTO to match.
	* Exported to .rst and .texi.

	python: key import via HKP example.
	+ commit fe7e01d164b64ad5e7f65cb80e4bf13f06d8d3ef
	* Fixed the logic used to search for any given pattern.
	* Added a sensible method of checking whether a pattern is a key ID or
	  fingerprint.

	python: docs updates.
	+ commit 7c63bfe4ab434b61a871aec4bc1d0a05b4c068e6
	* Multiple updates, expanding on the Windows installation issues.
	* Also adding to the new maintenance mode reference document.
	* Includes content relating to the resolution of T4271 and T4191.

2018-12-07  Andre Heinecke  <aheinecke@intevation.de>

	core: Fix ERR_INV_ARG check in genkey_start.
	+ commit 78f6291a3bf56769f53af66fe39718ddd2d74bf2
	* src/genkey.c (gpgme_op_genkey_start): Fix check for
	parms.

2018-12-05  Ben McGinnes  <ben@adversary.org>

	python: examples.
	+ commit dc5600d306f808767068bad5117232fc3d35ac43
	* cut some of then poor len usage.

2018-12-05  Daniel Kahn Gillmor  <dkg@fifthhorseman.net>

	python: overhaul logic of Context.decrypt()
	+ commit 65c28da4e49a8778607fdcf6f51a840166616d9f
	* lang/python/src/core.py (Context.decrypt): simplify and clarify the
	logic behind handling verify=False.
	* lang/python/tests/t-decrypt.py: ensure that we test verify=False

	python: ctx.decrypt() has problematic error handling.
	+ commit 878a0ad01265dba5b06429276bdcc5c21fedb6f5
	* lang/python/src/core.py (Context.decrypt): document odd
	error-handling behavior as a potential problem to be addressed.

	python: Clarify the meaning of ctx.decrypt(verify=[])
	+ commit 5d8b4f74891af22379899ccee9e8ee849144eee3
	* lang/python/src/core.py (Context.decrypt): docstring clarification
	of what it means to pass an empty list to the verify argument.

	python: gpg.Context.decrypt verify_sigs and sink_result are bools.
	+ commit b8fa76a30c02afc3d7f6aad0a59bb613d1b711fc
	Both of these function-internal variables are never used for anything
	other than a binary state.  Implement them as the booleans they are.
	Otherwise, casual readers of the code might think that they're
	supposed to represent something other than a flag (e.g. "verify_sigs"
	could mean "the signatures to verify", and "sink_result" could mean
	"the place where we sink the result").

	Signed-Off-By: Daniel Kahn Gillmor <dkg@fifthhorseman.net>

	python: clarify documentation for verify argument for Context.decrypt()
	+ commit 49af6d76e55f348c7b3cece756d6ac643d17ee68
	It's easy to miss that verify can take a list of keys.  Make it more
	obvious to the average python dev who reads docstrings.

	python: simplify Context.decrypt()
	+ commit 2491e6f92f5b562cbd6f7f931df630cb106f6688
	In the course of trying to address https://dev.gnupg.org/T4271, i
	discovered that gpg.Context.decrypt() has a bit of superfluous code.
	This changeset is intended to simplify the code without making any
	functional changes.

2018-12-05  Ben McGinnes  <ben@adversary.org>

	python: windows c and cython.
	+ commit 1dffdcc6e9d249111eb8761d29ef3b35b32a8c3d
	* added warning that he Windows C runtime issues will also affect use
	  with Cython and that relying on binary installers would remove that
	  possible use case.

2018-12-04  Ben McGinnes  <ben@adversary.org>

	python: sphinx modification.
	+ commit c8a04af676d981b42172c9bdad82eb83f91c8ce6
	* The make.bat file incorrectly triggers the trailing whitespace check
	  in the git repo (it doesn't actually have any trailing whitespace,
	  but triggers the error on every line).
	* Will need to add a script to handle future org-mode conversions of
	  the index page anyway, so will get that script to deal with this
	  problem too by generating the make.bat file if the platform is
	  detected as Windows.

	python: Sphinx support.
	+ commit 6d8823b81162c18406d40ec59bd252cfdf1df648
	* Added framework from sphinx-quickstart to lang/python/doc/rst/ so
	  that Python developers already using Sphinx can use the generated
	  reST files with existing documentation systems.
	* Note that when generating source files from Org-mode, the index page
	  will require manual intervention to match the Sphinx requirements.

	python: docs update.
	+ commit 8613727f1ee985c3cfa2c815523312914f033ffd
	* Expanded the section on issues with Windows installations, with
	  greater detail of which versions of Visual Studio are needed
	  depending on which version of CPython is to be used.
	* Included a recommendation which is a bit harsh without being totally
	  prickish.
	* Updated all files to not link to author's key or related data in
	  order to make them all consistent with the changes in commit
	  649b19688132dd315e361c0f5b63ba6d8f45996d.

2018-12-04  NIIBE Yutaka  <gniibe@fsij.org>

	build: Remove --with-*-prefix, which is no need any more.
	+ commit 5dbac555f23bcec4adcfd82de61878f0f23ff272
	* autogen.rc (configure_opts): Remove --with-*-prefix.

2018-12-03  Andre Heinecke  <aheinecke@intevation.de>

	qt,cpp: Consistently use nullptr and override.
	+ commit 1d31420650bfa7ca1d1503cc7431b3360e86022c
	* lang/cpp/src/Makefile.am, lang/qt/src/Makefile.am (AM_CPPFLAGS):
	Add suggest-override and zero-as-null-pointer-constant warnings.

	* lang/cpp/src/*, lang/qt/src/*: Consistenly use nullptr and override.

2018-11-30  Ben McGinnes  <ben@adversary.org>

	python: documentation fixes.
	+ commit 2e3a681d0c35bbf6db584fedc9d7f0a010430b51
	* Typographic and whitespace error correction pertaining to the
	  previous update.

	python: documentation.
	+ commit 3b056a01a252bb72df5744409ba494e1a6e54d31
	* Added long description to setup.py.in.
	* Added maintenance mode details with clarification for what type of
	  things would be a bug as far as MM is concerned and what wouldn't
	  be.
	** Includes a not too subtle hint directed towards the donations page.
	* Miscellaneous tightening of documentation.

2018-11-28  Andre Heinecke  <aheinecke@intevation.de>

	tests, json: Make them run on debian stable.
	+ commit a9cfb6dad8ac60543bcb06f4d0515f4a64ad897a
	* tests/json/t-json.c (main): Relax version check a bit.

2018-11-26  Ben McGinnes  <ben@adversary.org>

	python docs: checking key signatures.
	+ commit 1c92f3ff55ad0cdda06d05ad0a83193e3a147b7e
	* Added instructions for checking key certifications or key
	  signatures (depending on preferred terminology).
	* Added pendulum module to recommended installations, but not to
	  requirements.

2018-11-22  Ben McGinnes  <ben@adversary.org>

	python: docs update.
	+ commit c87155e6eba2e97e4e6c6ee7e2591088a5489556
	* Added documentation for the new methods added to gpgme.version.
	* Removed the Flask based advanced use case from the what-is-new
	  section as that type of code will not be added here.

	python: version as integers.
	+ commit de6bb23279796b9ae4dc369d58591cb75f818684
	* lang/python/version.py.in: added gpg.version.versionintlist
	* If gpg.version.versionintlist[2] ever returns -1 then there's a
	  serious problem with the build and it should be lodged as a bug if
	  it's repeatable.  Seeing this should never happen, but checking for
	  it is better than not doing so.

2018-11-19  Werner Koch  <wk@gnupg.org>

	core: Fix format string errors in w32-io.c and use of TRACE_SUC.
	+ commit b182838f71d8349d6cd7be9ecfb859b893d09127
	* src/w32-io.c: Fix use of TRACE_SUC.  Fix some format strung errors.

2018-11-19  Ben McGinnes  <ben@adversary.org>

	python: import type.
	+ commit fd34415bdd57332424bd5a98d279e2331678a2fb
	* Fixed bug T4242 and tested that dropping "Import" in favour of
	  "import_type" does indeed work just fine.

	python: import constant.
	+ commit f773ad392da57e6be4ade93c44baa5d2057c40b6
	* lang/python/src/constants/__init__.py: dropped use of Import
	  capitalisation and renamed lang/python/src/constants/import.py to
	  lang/python/src/constants/import_type.py to address bug T4242.
	* lang/python/doc/src/gpgme-python-howto: minor docs updates.

2018-11-16  Werner Koch  <wk@gnupg.org>

	core: Protect the trace macros for fun and profit.
	+ commit 7a1e7006d06fdbab86ea79a197c316744b09d933
	* src/debug.h: Protect macros using.
	(_trace_err, _trace_sysres, _trace_syserr): New helper inline
	functions.

	core: Fix a LF problem in the new debug fucntion.
	+ commit 7eda50a673d15320022375360fd220e8381b69ab
	* src/debug.c (_gpgme_debug): Print a LF for an empty FORMAT unless we
	are in legacy mode.

	core: Remove old debug helper function.
	+ commit 94d274a1a33c6fb30981290b127f2c4babc27245
	* src/debug.c (_gpgme_debug): Remove.
	(_gpgme_debugf): Rename to _gpgme_debug.

	core: Simplify the trace maros by using variadics.
	+ commit 5857491a2aa7d4975100d90f1ad62c08aa345e3e
	* src/debug.h (TRACE_BEG, TRACE_LOG, TRACE_SUC): Use variadic macros
	and remove the TRACE_BEG1 et al.  Change all users to always pass a
	format string.
	(TRACE): Ditto.
	* src/debug.c (_gpgme_debugf): New.
	* configure.ac <GCC>: Add -Wno-format-zero-length.

2018-11-15  Andre Heinecke  <aheinecke@intevation.de>

	tests: Add run-threaded for multithread tests.
	+ commit d0402f886b720d03369887c807581bd980ee70cf
	* tests/Makefile.am (run-threaded): Add.
	* tests/run-threaded.c: New.

	tests,json: Clean openpgp-revocs.d.
	+ commit 004e2cad2f26250cd010684f11dc187f08e6f9e1
	* tests/json/clean-local: Remove revocs.d

	tests,json: Move version check into t-json.
	+ commit 40d962b43a183070ba8602cac1e83f2292ebf2c3
	* tests/gpg/t-support.h (check_gpg_version, compare_versions),
	(parse_version_string, parse_version_number): Remove version
	check code.
	* tests/json/t-json.c (check_gpg_version, compare_versions),
	(parse_version_string, parse_version_number): Add.

2018-11-14  Andre Heinecke  <aheinecke@intevation.de>

	tests,json: Add sig-notations test.
	+ commit d3dae4a445d950c94c952ddf54e534ef71675bd1
	* tests/json/t-sig-notations.in.json,
	tests/json/t-sig-notations.out.json: New
	* tests/json/Makefile.am (EXTRA_DIST): Add files.
	* tests/json/t-json.c: Register it.

	tests,json: Fix distcheck.
	+ commit def030e843bd4576597272abe9fe12f846066576
	* tests/json/Makefile.am (EXTRA_DIST): Add inital and final scripts.
	(t_json_SOURCES): Don't use cJSON.o as source.

	tests,json: Add more tests.
	+ commit d0087d45f0207bf82a4f078d972c28c4d1cd2690
	* t-config-opt.in.json,
	 t-config-opt.out.json,
	 t-import.in.json,
	 t-import.out.json,
	 t-sign.in.json,
	 t-sign.out.json: New.

	tests,json: Add missing files and chunking test.
	+ commit 88b7221eb737a3102ec61ea385990b7ea7ef2b30
	* tests/json/Makefile.am, tests/json/final.test,
	tests/json/initial.test: New.
	* tests/json/t-chunking.in.json, tests/json/t-chunking.out.json:
	New test.
	* tests/json/t-json.c: Register new test.

	tests,json: Fix match if the first child differs.
	+ commit 27ca12e815c0a582d357641a04b889d648b8766e
	* tests/json/t-json.c (test_contains): Try all siblings of
	the haystack child.

	tests,json: Add the bulk of tests.
	+ commit dd4b80a5f640232bb44eb825ff5a74ec295fad10
	* t-json.c (tests): Register new tests.
	* t-createkey.in.json,
	  t-createkey.out.json,
	  t-decrypt-verify.in.json,
	  t-decrypt-verify.out.json,
	  t-decrypt.in.json,
	  t-decrypt.out.json,
	  t-delete.in.json,
	  t-delete.out.json,
	  t-encrypt-sign.in.json,
	  t-encrypt-sign.out.json,
	  t-encrypt.in.json,
	  t-encrypt.out.json,
	  t-export-secret-info.in.json,
	  t-export-secret-info.out.json,
	  t-export.in.json,
	  t-export.out.json,
	  t-json.c,
	  t-keylist-secret.in.json,
	  t-keylist-secret.out.json,
	  t-keylist.in.json,
	  t-keylist.out.json,
	  t-verify.in.json,
	  t-verify.out.json,
	  t-version.in.json,
	  t-version.out.json: New.

	tests,json: Add wildcard string matching.
	+ commit 9a31fdcb11d04d47dfcc38a8409b84436c549108
	* tests/json/t-json.c (test_contains): When searching for "*" accept
	every string.

	tests,json: Skip tests for older GnuPG versions.
	+ commit e55e467d5ffb32c428566a876616d309ef2d15cd
	* tests/json/t-json.c (main): Skip if version is not at least
	2.2.0

	tests,json: Suffix .json to test pattern.
	+ commit ca2e2b3d6973b1f942571ba65bd8b57153847777
	* tests/json/t-config.in, tests/json/t-config.out: Renamed.
	* t-json.c (run_test): Use new naming pattern.

	tests,gpg: Add version check hlp to t-support.
	+ commit 5b61c092e7444749b08e39ac5aa9fb0818e1a076
	* t-support.h (parse_version_number, parse_version_string)
	(compare_versions): New. Copy&Paste from src/version.c
	(check_gpg_version): New helper to check for a gpg version.

	tests,json: Improve verbose mode and add verbose 2.
	+ commit 9933641cce595ba308d0f3a1f3ae8f13a9743dd1
	* tests/json/t-json.c (main): Handle multiple verbose args.
	(test-contains): Improve verbose output

	tests,json: Fix and improve t-json.
	+ commit 3e5684d99b881787f9739e53fd8e8c22eadc2146
	* tests/json/t-json.c (run_test): Terminate argv array correctly.
	(run_test): Note and handle empty response.

	tests: Add json testrunner.
	+ commit 0c31837766e016227b3c8dfd44c476949cd4741e
	* configure.ac: Configure makefile.
	* tests/Makefile.am: Run json tests if gpg tests are run.
	* tests/json/t-json.c: New testrunner for json tests.
	* tests/json/t-config.in, tests/json/t-config.out: First test.

2018-11-13  NIIBE Yutaka  <gniibe@fsij.org>

	build: Update gpg-error.m4 and libassuan.m4.
	+ commit c4aa4af50f3102b251cfff9c9755e2dde8d1bd1f
	* m4/gpg-error.m4: Update from master.
	* m4/libassuan.m4: Update from master.

2018-11-12  NIIBE Yutaka  <gniibe@fsij.org>

	Fix the previous commit.
	+ commit 895176f42af3a1b13614f15dd537a426bb4ac16a


	build: Make gpgme.m4 use gpgrt-config with *.pc.
	+ commit 60828a505a1c74fd34476c181df2a588ea6f9c83
	* src/gpgme.m4 (_AM_PATH_GPGME_CONFIG): Use gpgrt-config with gpgme.pc
	when possible.
	(AM_PATH_GPGME_GLIB): Likewise with gpgme-glib.pc.

	build: Provide gpgme-glib.pc too.
	+ commit a76e145a1057e11953b71f804cf3a499c3ad5362
	* src/gpgme-glib.pc.in: New.
	* src/gpgme.pc.in (avail_lang): Remove.

	build: Provide gpgme.pc, generated by configure.
	+ commit f3e60521899e6126229b6efedc9f011b84122e11
	* configure.ac: Generate src/gpgme.pc.
	* src/Makefile.am (pkgconfigdir, pkgconfig_DATA): New.
	(EXTRA_DIST): Add gpgme.pc.in.
	* src/gpgme.pc.in: New.
	* src/gpgme-config.in: Use variables.

2018-11-08  Daniel Kahn Gillmor  <dkg@fifthhorseman.net>

	spelling: fix misspellings.
	+ commit 2557d0ae6ff0336b041129b7bf5c1e3a8c20a805


2018-11-06  Ben McGinnes  <ben@adversary.org>

	docs: python bindings.
	+ commit d0a5caf73c2d6b73dd043f62574c31946e4f347d
	* Continued restructuring as part of moving beyond mere;y the HOWTO
	  file.
	* Generated the alternative source files for reST and Texinfo.
	* Fixed some errors and updated links after moving the what's new
	  section to two new files (yes, two).

	python examples: another importer.
	+ commit 0cb625da84d7e5deeacad113c404a8bc2154c8e7
	* Fixed a similar type of bug with the non-protonmail importer.

	python examples: protonmail hkp scripts.
	+ commit 1b9d30db089e9de3ef859195ad58d2164a0231a0
	* fixed a bug in the import try statement for both versions.

2018-11-05  Werner Koch  <wk@gnupg.org>

	gpg: Avoid error diagnostics with --override-session-key.
	+ commit bded8ebc59c7fdad2617f4c9232a58047656834c
	* src/engine-gpg.c (gpg_decrypt): Add --no-keyring.

2018-11-03  Ben McGinnes  <ben@adversary.org>

	docs: typo.
	+ commit 13e09bd21a531b448f2f34b1f075315502b76fb6
	* lang/python/doc/src/gpgme-python-howto: s/Revokinging/Revoking/g

2018-11-02  Werner Koch  <wk@gnupg.org>

	w32: Fix a few compiler warnings.
	+ commit 5262ce0c815193fc901b00a9b4132925ba672df7
	* src/debug.h (TRACE_SYSERR_NR): New.
	* src/w32-io.c: Fix compiler warnings.

	w32: Log all errors from CloseHandle and WFSO in w32-io.
	+ commit ed3f5ad760a28566fa2571e0c7392467bfc3770d
	* src/w32-io.c (close_handle, _close_handle): New macro and function;
	use in place of all CloseHandle calls.
	(wait_for_single_object, _wait_for_single_object): Likewise.

	w32: Don't use CloseHandle on an arbitrary integer.
	+ commit 4faa0ccf58c7a0f64f51dcbc8466add660080414
	* src/assuan-support.c (my_waitpid): Do not close the PID = it is not
	a handle.

	w32: Revamp the closing of system objects.
	+ commit da89528ac39b687bfbed2209ca2637e3bd8e0ac5
	* src/w32-io.c (hddesc_t): New.
	(reader_context_s, writer_context_s): Replace file_sock and file_hd by
	the hddesc_t hdd.
	(fd_table): Ditto.  Add want_reader and want_writer.
	(hddesc_lock): New lock variable.
	(new_hddesc, ref_hddesc): New.
	(release_hddesc): New.
	(reader, writer): Call release_hddesc.
	(create_reader, create_writer): Change for new hddesc scheme.
	(destroy_reader, destroy_writer): Replace closing by a call to
	release_hddesc.
	(_gpgme_io_pipe): Change for new hddesc scheme.
	(_gpgme_io_close): Ditto.
	(_gpgme_io_dup): Ditto.  Use want_reader and want_writer.
	(_gpgme_io_socket): Change for new hddesc scheme.

	core: Print a dump of the I/O data only at level 8.
	+ commit 337c10825525d4084f3f437fde5af3806707e6a4
	* src/debug.h (TRACE_SUC3): New.
	(TRACE_LOGBUFX): New.
	* src/posix-io.c: Use TRACE_LOGBUFX instead of TRACE_LOGBUF.
